<?php

defined('_JEXEC') or exit('Direct Access to ' . basename(__FILE__) . 'is not allowed.');

class PlgSystemFraudlabspro extends JPlugin
{
	public function plgVmConfirmedOrder($cart, $order)
	{
		$quantity = 1;

		foreach ($order['items'] as $item) {
			$quantity += $item->product_quantity;
		}

		$response = $this->fetch('https://api.fraudlabspro.com/v2/order/screen', [
			'key'            => $this->getApiKey(),
			'format'         => 'json',
			'ip'             => $this->getClientIp(),
			'first_name'     => $order['details']['BT']->first_name,
			'last_name'      => $order['details']['BT']->last_name,
			'bill_city'      => $order['details']['BT']->city,
			'bill_state'     => $this->getStateById($order['details']['BT']->virtuemart_state_id),
			'bill_country'   => $this->getCountryCodeById($order['details']['BT']->virtuemart_country_id),
			'bill_zip_code'  => $order['details']['BT']->zip,
			'user_phone'     => $order['details']['BT']->phone_1,
			'ship_addr'      => trim($order['details']['ST']->address_1 . ' ' . $order['details']['ST']->address_2),
			'ship_city'      => $order['details']['ST']->city,
			'ship_state'     => $this->getStateById($order['details']['ST']->virtuemart_state_id),
			'ship_zip_code'  => $order['details']['ST']->zip,
			'ship_country'   => $this->getCountryCodeById($order['details']['ST']->virtuemart_country_id),
			'email'          => $order['details']['BT']->email,
			'email_domain'   => substr($order['details']['BT']->first_name, strpos($order['details']['BT']->first_name, '@') + 1),
			'email_hash'     => $hash,
			'user_order_id'  => $order['details']['BT']->virtuemart_order_id,
			'amount'         => $order['details']['BT']->order_total,
			'quantity'       => $quantity,
			'currency'       => $this->getCurrencyCodeById($order['details']['BT']->order_currency),
			'payment_mode'   => $this->getPaymentMethodById($order['details']['BT']->virtuemart_paymentmethod_id),
			'source'         => 'virtuemart',
			'source_version' => '1.3.0',
		]);

		if (($json = json_decode((string) $response['body'])) !== null) {
			$db = JFactory::getDBO();

			$db->setQuery('INSERT INTO `#__virtuemart_orders_fraudlabspro` VALUES(\'' . implode('\',\'', [
				$order['details']['BT']->virtuemart_order_id,
				($json->billing_address->is_ip_country_match) ? 'Y' : 'N',
				'',
				$json->billing_address->ip_distance_in_km,
				$json->billing_address->ip_distance_in_mile,
				$ip,
				$json->ip_geolocation->country_code,
				$json->ip_geolocation->continent,
				$json->ip_geolocation->region,
				$json->ip_geolocation->city,
				$json->ip_geolocation->latitude,
				$json->ip_geolocation->longitude,
				$json->ip_geolocation->timezone,
				$json->ip_geolocation->elevation,
				$json->ip_geolocation->domain,
				$json->ip_geolocation->mobile_mnc,
				$json->ip_geolocation->mobile_mcc,
				$json->ip_geolocation->mobile_brand,
				$json->ip_geolocation->netspeed,
				$json->ip_geolocation->isp_name,
				implode(', ', $json->ip_geolocation->usage_type),
				($json->email_address->is_free) ? 'Y' : 'N',
				($json->email_address->is_new_domain_name) ? 'Y' : 'N',
				($json->ip_geolocation->is_proxy) ? 'Y' : 'N',
				($json->credit_card->is_bin_exist) ? 'Y' : 'N',
				($json->credit_card->is_bin_country_match) ? 'Y' : 'N',
				'',
				'',
				($json->credit_card->is_prepaid) ? 'Y' : 'N',
				($json->shipping_address->is_address_ship_forward) ? 'Y' : 'N',
				($json->shipping_address->is_bill_city_match) ? 'Y' : 'N',
				($json->shipping_address->is_bill_state_match) ? 'Y' : 'N',
				($json->shipping_address->is_bill_country_match) ? 'Y' : 'N',
				($json->shipping_address->is_bill_postcode_match) ? 'Y' : 'N',
				($json->ip_geolocation->is_in_blacklist) ? 'Y' : 'N',
				($json->email_address->is_in_blacklist) ? 'Y' : 'N',
				($json->credit_card->is_in_blacklist) ? 'Y' : 'N',
				($json->device->is_in_blacklist) ? 'Y' : 'N',
				($json->username->is_in_blacklist) ? 'Y' : 'N',
				$json->fraudlabspro_score,
				0,
				$json->fraudlabspro_status,
				$json->fraudlabspro_id,
				$json->fraudlabspro->error->error_code ?? '',
				$json->fraudlabspro->error->error_message ?? '',
				$json->remaining_credits,
				$this->getApiKey(),
			]) . '\')');
			$db->query();
		}
	}

	public function plgVmOnShowOrderBEShipment($orderId, $lineId)
	{
		$db = JFactory::getDBO();

		$query = 'SELECT * FROM `#__virtuemart_orders_fraudlabspro` WHERE id_order = ' . (int) $orderId;

		$db->setQuery($query);

		$row = $db->loadObjectList();

		$html = '
		<style type="text/css">
			.fraudlabspro{border:1px solid #ccced7;border-collapse:collapse;margin:auto;padding:4px;table-layout:fixed;width:100%}
			.fraudlabspro td{border-bottom:1px solid #ccced7;border-left:1px solid #ccced7;color:#678197;padding:2px 4px;text-align:left;white-space:nowrap;font-size:11px}
		</style>
		<table class="fraudlabspro">
		<col width="140">
		<col width="115">
		<col width="115">
		<col width="115">
		<col width="115">
		<tr style="background-color:#AB1B1C">
			<td colspan="5"><img src="https://www.fraudlabspro.com/images/logo_200.png" width="100" height="18"></td>
		</tr>';

		if (!$row) {
			$html .= '
			<tr>
				<td colspan="5">This order is not screened by FraudLabs Pro.</td>
			</tr>';
		} else {
			$row = $row[0];

			$location = [];

			if (strlen($row->ip_country) == 2) {
				$location = [_c($row->ip_continent), _c($this->getCountryNameByCode($row->ip_country)), _c($row->ip_region), _c($row->ip_city)];
				$location = array_unique($location);
			}

			$html .= '
			<tr>
				<td rowspan="3" height="200">
					<div align="center">
						<b>FraudLabs Pro Score</b> <a href="javascript:;" title="Risk score, 0 (low risk) - 100 (high risk).">[?]</a>
						<p><img class="img-responsive" alt="" src="//fraudlabspro.hexa-soft.com/images/fraudscore/fraudlabsproscore' . $row->flp_score . '.png" width="110" height="86" /></p>
					</div>
				</td>
				<td>
					<b>Transaction ID</b> <a href="javascript:;" title="Unique identifier for a transaction screened by FraudLabs Pro system.">[?]</a>
					<p><a href="http://www.fraudlabspro.com/merchant/transaction-details/' . $row->flp_id . '" target="_blank">' . $row->flp_id . '</a></p>
				</td>
				<td>
					<b>IP Address</b>
					<p>' . $row->ip_address . '</p>
				</td>
				<td colspan="2">
					<b>IP Location</b> <a href="javascript:;" title="Location of the IP address.">[?]</a>
					<p>' . implode(', ', $location) . ' <a href="http://www.geolocation.com/' . $row->ip_address . '" target="_blank">[Map]</a></p>
				</td>
			</tr>
			<tr>
				<td>
					<b>IP Net Speed</b> <a href="javascript:;" title="Connection speed.">[?]</a>
					<p>' . $row->ip_netspeed . '</p>
				</td>
				<td colspan="3">
					<b>IP ISP Name</b> <a href="javascript:;" title="ISP of the IP address.">[?]</a>
					<p>' . $row->ip_isp_name . '</p>
				</td>
			</tr>';

			switch ($row->flp_status) {
				case 'REVIEW':
					$color = 'ffcc00';
					break;

				case 'REJECT':
					$color = 'cc0000';
					break;

				case 'APPROVE':
					$color = '336600';
					break;
			}

			$html .= '
			<tr>
				<td>
					<b>IP Domain</b> <a href="javascript:;" title="EDomain name of the IP address.">[?]</a>
					<p>' . $row->ip_domain . '</p>
				</td>
				<td>
					<b>IP Usage Type</b> <a href="javascript:;" title="Usage type of the IP address. E.g, ISP, Commercial, Residential.">[?]</a>
					<p>' . $row->ip_usage_type . '</p>
				</td>
				<td>
					<b>IP Time Zone</b> <a href="javascript:;" title="Time zone of the IP address.">[?]</a>
					<p>' . $row->ip_timezone . '</p>
				</td>
				<td>
					<b>IP Distance</b> <a href="javascript:;" title="Distance from IP address to Billing Location.">[?]</a>
					<p>' . (($row->distance_in_km) ? ($row->distance_in_km . ' KM / ' . $row->distance_in_mile . ' Miles') : '-') . '</p>
				</td>
			</tr>
			<tr>
				<td rowspan="3" height="200">
					<center><b>FraudLabs Pro Status</b> <a href="javascript:;" title="FraudLabs Pro status.">[?]</a>
					<p style="color:#' . $color . ';font-size:30px;margin-top:5px">' . $row->flp_status . '</p></center>
				</td>
				<td>
					<b>IP Latitude</b> <a href="javascript:;" title="Latitude of the IP address.">[?]</a>
					<p>' . $row->ip_latitude . '</p>
				</td>
				<td>
					<b>IP Longitude</b> <a href="javascript:;" title="Longitude of the IP address.">[?]</a>
					<p>' . $row->ip_longitude . '</p>
				</td>
				<td colspan="2">&nbsp;</td>
			</tr>
			<tr>
				<td>
					<b>Free Email</b> <a href="javascript:;" title="Whether e-mail is from free e-mail provider.">[?]</a>
					<p>' . (($row->is_free_email == 'Y') ? 'Yes' : (($row->is_free_email == 'N') ? 'No' : '-')) . '</p>
				</td>
				<td>
					<b>Ship Forward</b> <a href="javascript:;" title="Whether shipping address is a freight forwarder address.">[?]</a>
					<p>' . (($row->is_address_ship_forward == 'Y') ? 'Yes' : (($row->is_address_ship_forward == 'N') ? 'No' : '-')) . '</p>
				</td>
				<td>
					<b>Using Proxy</b> <a href="javascript:;" title="Whether IP address is from Anonymous Proxy Server.">[?]</a>
					<p>' . (($row->is_proxy_ip_address == 'Y') ? 'Yes' : (($row->is_proxy_ip_address == 'N') ? 'No' : '-')) . '</p>
				</td>
				<td colspan="2">&nbsp;</td>
			</tr>
			<tr>
				<td>
					<b>BIN Found</b> <a href="javascript:;" title="Whether the BIN information matches our BIN list.">[?]</a>
					<p>' . (($row->is_bin_found == 'Y') ? 'Yes' : (($row->is_bin_found == 'N') ? 'No' : '-')) . '</p>
				</td>
				<td>
					<b>Email Blacklist</b> <a href="javascript:;" title="Whether the email address is in our blacklist database.">[?]</a>
					<p>' . (($row->is_email_blacklist == 'Y') ? 'Yes' : (($row->is_email_blacklist == 'N') ? 'No' : '-')) . '</p>
				</td>
				<td>
					<b>Credit Card Blacklist</b> <a href="javascript:;" title="Whether the credit card is in our blacklist database.">[?]</a>
					<p>' . (($row->is_credit_card_blacklist == 'Y') ? 'Yes' : (($row->is_credit_card_blacklist == 'N') ? 'No' : '-')) . '</p>
				</td>
				<td>
					<b>Balance</b> <a href="javascript:;" title="Balance of the credits available after this transaction.">[?]</a>
					<p>' . $row->flp_credits . ' [<a href="http://www.fraudlabspro.com/plan" target="_blank">Upgrade</a>]</p>
				</td>
			</tr>
			<tr>
				<td colspan="5">
					<b>Message</b> <a href="javascript:;" title="FraudLabs Pro error message description.">[?]</a>
					<p>' . (($row->flp_message) ? $row->flp_error_code . ':' . $row->flp_message : '-') . '</p>
			</tr>
			<tr>
				<td colspan="5">
					<p>Please login to <a href="https://www.fraudlabspro.com/merchant/login" target="_blank">FraudLabs Pro Merchant Area</a> for more information about this order.</p>
			</tr>
			</table>';
		}

		$html .= '</table>';

		echo '
		<script>
		jQuery(function($) {
			$(\'#order-items-table\').parent().append(\'' . preg_replace('/[\n\t]+/', '', $html) . '\');
		});
		</script>';
	}

	private function hash($s)
	{
		$prefix = 'fraudlabspro_';

		$hash = $prefix . $s;

		for ($i = 0; $i < 65536; ++$i) {
			$hash = sha1($prefix . $hash);
		}

		return $hash;
	}

	private function getClientIp()
	{
		$headers = [
			'HTTP_CF_CONNECTING_IP', 'X-Real-IP', 'HTTP_X_FORWARDED_FOR', 'HTTP_INCAP_CLIENT_IP', 'HTTP_X_SUCURI_CLIENTIP',
		];

		foreach ($headers as $header) {
			if (isset($_SERVER[$header]) && filter_var($_SERVER[$header], FILTER_VALIDATE_IP, FILTER_FLAG_NO_PRIV_RANGE | FILTER_FLAG_NO_RES_RANGE)) {
				return $_SERVER[$header];
			}
		}

		return $_SERVER['REMOTE_ADDR'];
	}

	private function getCurrencyCodeById($id)
	{
		$db = JFactory::getDBO();
		$db->setQuery('SELECT `currency_code_3` FROM `#__virtuemart_currencies` WHERE `virtuemart_currency_id`="' . (int) $id . '"');

		return $db->loadResult();
	}

	private function getStateById($id)
	{
		$db = JFactory::getDBO();
		$db->setQuery('SELECT `state_2_code` FROM `#__virtuemart_states` WHERE `virtuemart_state_id`="' . (int) $id . '"');

		return $db->loadResult();
	}

	private function getCountryNameByCode($code)
	{
		$db = JFactory::getDBO();
		$db->setQuery('SELECT `country_name` FROM `#__virtuemart_countries` WHERE `country_2_code`="' . $code . '"');

		return $db->loadResult();
	}

	private function getCountryCodeById($id)
	{
		$db = JFactory::getDBO();
		$db->setQuery('SELECT `country_2_code` FROM `#__virtuemart_countries` WHERE `virtuemart_country_id`="' . (int) $id . '"');

		return $db->loadResult();
	}

	private function getPaymentMethodById($id)
	{
		$db = JFactory::getDBO();
		$db->setQuery('SELECT `payment_element` FROM `#__virtuemart_paymentmethods` WHERE `virtuemart_paymentmethod_id`="' . (int) $id . '"');

		switch ($db->loadResult()) {
			case 'standard':
				return 'COD';

			case 'paypal':
				return 'paypal';

			case 'skrill':
			case 'stripe':
				return 'creditcard';
		}

		return 'others';
	}

	private function fetch($url, $fields = [], $options = [], $cookies = [])
	{
		$http = curl_init();

		curl_setopt($http, CURLOPT_URL, $url);
		curl_setopt($http, CURLOPT_FAILONERROR, true);
		curl_setopt($http, CURLOPT_FOLLOWLOCATION, true);
		curl_setopt($http, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($http, CURLOPT_HEADER, true);
		curl_setopt($http, CURLOPT_SSL_VERIFYPEER, false);
		curl_setopt($http, CURLOPT_ENCODING, 'gzip, deflate');
		curl_setopt($http, CURLOPT_HTTP_VERSION, '1.1');

		if (isset($options['method'])) {
			curl_setopt($http, CURLOPT_CUSTOMREQUEST, $options['method']);

			if ($options['method'] == 'PUT') {
				curl_setopt($http, CURLOPT_POSTFIELDS, $fields);
			}
		} elseif (!empty($fields)) {
			curl_setopt($http, CURLOPT_POST, true);
			curl_setopt($http, CURLOPT_POSTFIELDS, (is_array($fields)) ? http_build_query($fields) : $fields);
		}

		if (isset($options['referer'])) {
			curl_setopt($http, CURLOPT_REFERER, $options['referer']);
		}

		if (isset($options['user_agent'])) {
			curl_setopt($http, CURLOPT_USERAGENT, $options['user_agent']);
		} else {
			curl_setopt($http, CURLOPT_USERAGENT, 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:98.0) Gecko/20100101 Firefox/98.0');
		}

		if (isset($options['headers'])) {
			curl_setopt($http, CURLOPT_HTTPHEADER, $options['headers']);
		}

		if (isset($options['password'])) {
			curl_setopt($http, CURLOPT_USERPWD, $options['password']);
		}

		if ($cookies) {
			curl_setopt($http, CURLOPT_HTTPHEADER, [
				'Cookie: ' . http_build_query($cookies, '', '; '),
			]);
		}

		$response = curl_exec($http);

		if (curl_errno($http)) {
			return false;
		}

		if (preg_match_all('/^Set-Cookie:\s*([^;]*)/mi', $response, $matches)) {
			foreach ($matches[1] as $item) {
				parse_str($item, $rows);

				foreach ($rows as $key => $value) {
					$cookies[$key] = $value;
				}
			}
		}

		list($header, $body) = explode("\r\n\r\n", $response, 2);

		return [
			'header'  => $header,
			'cookies' => $cookies,
			'body'    => $body,
		];
	}

	private function getApiKey()
	{
		$plugin = JPluginHelper::getPlugin('system', 'fraudlabspro');
		$pluginParams = new JRegistry();
		$pluginParams->loadString($plugin->params);

		return $pluginParams->get('flp_license', 'flp_license');
	}
}
